<?php
/**
 * @copyright	Copyright (C) 2009-2015 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingJajobboard extends JPlugin
{
	function plgAcymailingJajobboard(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'jajobboard');
			$this->params = new acyParameter( $plugin->params );
		}
	}

	function onAcyDisplayFilters(&$type,$context="massactions"){

		if($this->params->get('displayfilter_'.$context,true) == false) return;

		$type['jajobboard'] ='JA Job Board';
		$type['jajobboardprofiles'] ='JA Job Board Employers';
		$type['jajobboardresumes'] ='JA Job Board Job Seekers';

		$groupsin = acymailing_get('type.operatorsin');
		$groupsin->js = 'onchange="countresults(__num__)"';

		$groups = array();
		$groups[] = JHTML::_('select.option', 'employers','Employers');
		$groups[] = JHTML::_('select.option', 'jobseekers','Job Seekers');

		$return = '<div id="filter__num__jajobboard">'.$groupsin->display("filter[__num__][jajobboard][type]");
		$return .= ' '.JHTML::_('select.genericlist',   $groups, "filter[__num__][jajobboard][group]", 'onchange="countresults(__num__)" class="inputbox" size="1"');
		$return .= '<br /><input type="text" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" name="filter[__num__][jajobboard][join_date_inf]" value=""/> < '.JText::_('CREATED_DATE').' < <input type="text" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" name="filter[__num__][jajobboard][join_date_sup]" value=""/>';
		$return .= '<br /><input type="text" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" name="filter[__num__][jajobboard][expiry_date_inf]" value=""/> < '.JText::_('EXPIRY_DATE').' < <input type="text" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" name="filter[__num__][jajobboard][expiry_date_sup]" value=""/>';
		$return .= '</div>';

		$operators = acymailing_get('type.operators');
		$operators->extra = 'onchange="countresults(__num__)"';

		//Profile for employers
		$tablename = array('profiles','resumes');
		foreach($tablename as $oneTableName){
			$fields = acymailing_getColumns('#__ja_'.$oneTableName);
			$field = array();
			foreach($fields as $oneField => $fieldType){
				$field[] = JHTML::_('select.option',$oneField,$oneField);
			}

			$return .= '<div id="filter__num__jajobboard'.$oneTableName.'">'.JHTML::_('select.genericlist',   $field, "filter[__num__][jajobboard$oneTableName][map]", 'onchange="countresults(__num__)" class="inputbox" size="1"', 'value', 'text');
			$return .= ' '.$operators->display("filter[__num__][jajobboard$oneTableName][operator]").' <input onchange="countresults(__num__)" class="inputbox" type="text" name="filter[__num__][jajobboard'.$oneTableName.'][value]" style="width:200px" value=""></div>';
		}

	 	return $return;
	}

	function onAcyProcessFilterCount_jajobboardprofiles(&$query,$filter,$num){
		$this->onAcyProcessFilter_jajobboardprofiles($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_jajobboardprofiles(&$query,$filter,$num){
	 	$query->leftjoin['japrofiles'] = "#__ja_profiles as japrofiles ON sub.userid = japrofiles.user_id";
	 	$query->where[] = $query->convertQuery("japrofiles",$filter['map'],$filter['operator'],$filter['value']);
	}

	function onAcyProcessFilterCount_jajobboardresumes(&$query,$filter,$num){
		$this->onAcyProcessFilter_jajobboardresumes($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_jajobboardresumes(&$query,$filter,$num){
	 	$query->leftjoin['jaresumes'] = "#__ja_resumes as jaresumes ON sub.userid = jaresumes.user_id";
	 	$query->where[] = $query->convertQuery("jaresumes",$filter['map'],$filter['operator'],$filter['value']);
	}

	function _makeLJ($filter,$num){
	 	$db = JFactory::getDBO();

	 	$lj = "`#__ja_".$filter['group']."` as jajobboard$num ON jajobboard$num.`user_id` = sub.`userid`";
	 	if(!empty($filter['join_date_inf'])){
	 		$filter['join_date_inf'] = acymailing_replaceDate($filter['join_date_inf']);
	 		if(is_numeric($filter['join_date_inf'])) $filter['join_date_inf'] = date('Y-m-d H:i',$filter['join_date_inf']);
	 		$lj .= " AND jajobboard$num.`join_date` > ".$db->Quote($filter['join_date_inf']);
	 	}
	 	if(!empty($filter['join_date_sup'])){
	 		$filter['join_date_sup'] = acymailing_replaceDate($filter['join_date_sup']);
	 		if(is_numeric($filter['join_date_sup'])) $filter['join_date_sup'] = date('Y-m-d H:i',$filter['join_date_sup']);
	 		$lj .= " AND jajobboard$num.`join_date` < ".$db->Quote($filter['join_date_sup']);
	 	}
	 	if(!empty($filter['expiry_date_inf'])){
	 		$filter['expiry_date_inf'] = acymailing_replaceDate($filter['expiry_date_inf']);
	 		if(is_numeric($filter['expiry_date_inf'])) $filter['expiry_date_inf'] = date('Y-m-d H:i',$filter['expiry_date_inf']);
	 		$lj .= " AND jajobboard$num.`expiry_date` > ".$db->Quote($filter['expiry_date_inf']);
	 	}
	 	if(!empty($filter['expiry_date_sup'])){
	 		$filter['expiry_date_sup'] = acymailing_replaceDate($filter['expiry_date_sup']);
	 		if(is_numeric($filter['expiry_date_sup'])) $filter['expiry_date_sup'] = date('Y-m-d H:i',$filter['expiry_date_sup']);
	 		$lj .= " AND jajobboard$num.`expiry_date` < ".$db->Quote($filter['expiry_date_sup']);
	 	}

	 	return $lj;
	}

	function onAcyProcessFilterCount_jajobboard(&$query,$filter,$num){
		$this->onAcyProcessFilter_jajobboard($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_jajobboard(&$query,$filter,$num){
	 	$query->leftjoin['jajobboard_'.$num] = $this->_makeLJ($filter,$num);

	 	$operator = ($filter['type'] == 'IN') ? 'IS NOT NULL' : "IS NULL";
	 	$query->where[] = "jajobboard$num.`user_id` ".$operator;
	}
}//endclass